/*
       3Ցty 02
	2003/12/30  ˁ@P
*/
#include <windows.h>
#include <mmsystem.h>

#pragma comment(lib, "winmm.lib")

LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);

HINSTANCE g_hInstance;

HWND g_hwMain;

HBITMAP g_hbmpKey, g_hbmpOld;
HDC g_hdcKey;
HBRUSH g_hbPos;

RECT g_arecKey[20];
HBRUSH g_hbKey[20];
RECT g_arecPos[20];

RECT g_recKey = {0, 0, 240, 40};

BOOL g_abKeyMap[20], g_abToneMap[20];

/* ՉzL[R[hݒ */
int g_iKeyCode[20] = {'A', 'W', 'S', 'D', 'R', 'F', 'T', 'G', 'H', 'U', 'J', 'I', 'K', 'O', 'L', 0xbb, 0xc0, 0xba, 0xdb, 0xdd};

/* o0a */
BYTE g_byO0A = 21;

/* xVeBݒ */
BYTE g_byVc = 96;

/* Œቹ(A)o4aɐݒ */
int g_iOc = 4;

/* F */
BYTE g_abyInpl[5] = {0, 16, 40, 74, 80};
int g_iInplIndex = 0;

HMIDIOUT g_hMidi;

void midi() {

	int i, j;
	DWORD dwCommand;
	BYTE byCommand, byArg1, byArg2;

	/* tHAOhłȂΑ󂯓Ȃ */
	if (GetForegroundWindow() != g_hwMain) {
		return;
	}

	/* Œቹ(A)̃L[ݒ */
	BYTE byBase = g_byO0A + g_iOc * 12;

	/* m[gIR}h */
	byCommand = 0x90;

	for (i = 0;i < 20;i++) {

		/* ẽL[󋵎擾 */
		g_abKeyMap[i] = GetAsyncKeyState(g_iKeyCode[i]);

		if (g_abKeyMap[i] && !g_abToneMap[i]) { /* ꂽ */

			g_abToneMap[i] = TRUE;

			byArg1 = byBase + i;
			byArg2 = g_byVc;

			dwCommand = byArg2 * 65536 + byArg1 * 256 + byCommand;

			/* m[gIbZ[WM */
			midiOutShortMsg(g_hMidi, dwCommand);

		}

		if (!g_abKeyMap[i] && g_abToneMap[i]) { /* ꂽ */

			g_abToneMap[i] = FALSE;

			byArg1 = byBase + i;
			byArg2 = 0x00;

			dwCommand = byArg2 * 65536 + byArg1 * 256 + byCommand;

			/* m[gIijbZ[WM */
			midiOutShortMsg(g_hMidi, dwCommand);

		}

	}

	/* \prbg}bvNA */
	FillRect(g_hdcKey, &g_recKey, GetStockObject(GRAY_BRUSH));

	/* rbg}bvɌՁij` */
	for (i = 0;i < 20;i++) {

		if (g_arecKey[i].bottom == 40) {
			FillRect(g_hdcKey, &g_arecKey[i], GetStockObject(WHITE_BRUSH));
		}

	}

	/* rbg}bvɌՁij` */
	for (i = 0;i < 20;i++) {

		if (g_arecKey[i].bottom != 40) {
			FillRect(g_hdcKey, &g_arecKey[i], GetStockObject(BLACK_BRUSH));
		}

	}

	/* rbg}bvɔ󋵕` */
	for (i = 0;i < 20;i++) {

		if (g_abToneMap[i]) {
			FillRect(g_hdcKey, &g_arecPos[i], g_hbPos);
		}

	}

	/* FύX */
	if (GetAsyncKeyState(VK_LEFT) < 0 && g_iInplIndex > 0) {

		g_iInplIndex--;

		byCommand = 0xc0;
		byArg1 = g_abyInpl[g_iInplIndex];
		byArg2 = 0;

		dwCommand = byArg2 * 65536 + byArg1 * 256 + byCommand;

		/* vO`FWbZ[WM */
		midiOutShortMsg(g_hMidi, dwCommand);

		Sleep(100);

	}

	/* FύX */
	if (GetAsyncKeyState(VK_RIGHT) < 0 && g_iInplIndex < 4) {

		g_iInplIndex++;

		byCommand = 0xc0;
		byArg1 = g_abyInpl[g_iInplIndex];
		byArg2 = 0;

		dwCommand = byArg2 * 65536 + byArg1 * 256 + byCommand;

		/* vO`FWbZ[WM */
		midiOutShortMsg(g_hMidi, dwCommand);

		Sleep(100);

	}

	/* xVeBύX */
	if (GetAsyncKeyState(VK_UP) < 0 && g_byVc < 120) {

		g_byVc += 4;

		Sleep(10);

	}

	/* xVeBύX */
	if (GetAsyncKeyState(VK_DOWN) < 0 && g_byVc > 40) {

		g_byVc -= 4;

		Sleep(10);

	}

	/* 0-5ōŒቹݒ */
	for (i = 0;i < 6;i++) {

		/* 0-5̃L[͌o */
		if (GetAsyncKeyState(48 + i) < 0) {

			/* ݔ̃m[gׂăIt */
			for (j = 0;j < 20;j++) {

				g_abKeyMap[j] = FALSE;

				if (g_abToneMap[j]) {

					g_abToneMap[j] = FALSE;

					byArg1 = byBase + j;
					byArg2 = 0x00;

					dwCommand = byArg2 * 65536 + byArg1 * 256 + byCommand;

					/* m[gIijbZ[WM */
					midiOutShortMsg(g_hMidi, dwCommand);

					Sleep(10);

				}

			}

			/* Œቹ̐ݒύX */
			g_iOc = i;

		}
	}

	/* ĕ` */
	InvalidateRgn(g_hwMain, NULL, FALSE);

}

int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance,
                    PSTR szCmdLine, int iCmdShow){

	MSG  msg;
	WNDCLASS wndclass;

	MIDIHDR mhMidi;

	/* GMZbgR[h */
	BYTE abyGMReset[6]={0xf0, 0x7e, 0x7f, 0x09, 0x01, 0xf7};

	int i;

	/* MIDIfoCXI[v */
	if (midiOutOpen(&g_hMidi, MIDIMAPPER, 0, 0, 0) != MMSYSERR_NOERROR) {

		MessageBox(NULL, "MIDĨI[vɎs܂B", "s", MB_OK);

		return 0;

	}

	ZeroMemory(&mhMidi, sizeof(mhMidi));

	/* GMZbgMpobt@ݒ */
	mhMidi.lpData = (LPSTR)abyGMReset;
	mhMidi.dwBufferLength = 6;
	mhMidi.dwBytesRecorded = 6;

	midiOutPrepareHeader(g_hMidi, &mhMidi, sizeof(mhMidi));

	/* GMZbgM */
    if (midiOutLongMsg(g_hMidi, &mhMidi, sizeof(mhMidi)) != MMSYSERR_NOERROR) {

		midiOutUnprepareHeader(g_hMidi, &mhMidi, sizeof(mhMidi));

		MessageBox(NULL, "MIDĨZbgɎs܂B", "s", MB_OK);

		midiOutClose(g_hMidi);

		return 0;

	}
	
	i = 0;

	/* GMZbgҋ@ */
	do {
		Sleep(20);
	} while (mhMidi.dwFlags & MHDR_DONE == 0 && ++i < 10);

    if (i == 10) {

		MessageBox(NULL, "MIDĨZbgɎs܂B", "s", MB_OK);

		midiOutClose(g_hMidi);

		return 0;

	}

	midiOutUnprepareHeader(g_hMidi, &mhMidi, sizeof(mhMidi));

	/* Օ\prbg}bv쐬 */
	g_hbmpKey = CreateCompatibleBitmap(GetDC(0) , 240, 40);
	g_hdcKey = CreateCompatibleDC(GetDC(0));

	g_hbmpOld = SelectObject(g_hdcKey, g_hbmpKey);

	/* 󋵕`puV쐬 */
	g_hbPos = CreateSolidBrush(0x000040ff);

	/* a */
	g_arecKey[0].left = 1;
	g_arecKey[0].top = 0;
	g_arecKey[0].right = 20;
	g_arecKey[0].bottom = 40;

	g_arecPos[0].left = 4;
	g_arecPos[0].top = 30;
	g_arecPos[0].right = 15;
	g_arecPos[0].bottom = 38;

	/* b- */
	g_arecKey[1].left = 14;
	g_arecKey[1].top = 0;
	g_arecKey[1].right = 24;
	g_arecKey[1].bottom = 20;

	g_arecPos[1].left = 15;
	g_arecPos[1].top = 10;
	g_arecPos[1].right = 23;
	g_arecPos[1].bottom = 18;

	/* b */
	g_arecKey[2].left = 21;
	g_arecKey[2].top = 0;
	g_arecKey[2].right = 40;
	g_arecKey[2].bottom = 40;

	g_arecPos[2].left = 24;
	g_arecPos[2].top = 30;
	g_arecPos[2].right = 35;
	g_arecPos[2].bottom = 38;

	/* C */
	g_arecKey[3].left = 41;
	g_arecKey[3].top = 0;
	g_arecKey[3].right = 60;
	g_arecKey[3].bottom = 40;

	g_arecPos[3].left = 44;
	g_arecPos[3].top = 30;
	g_arecPos[3].right = 55;
	g_arecPos[3].bottom = 38;

	/* C# */
	g_arecKey[4].left = 54;
	g_arecKey[4].top = 0;
	g_arecKey[4].right = 64;
	g_arecKey[4].bottom = 20;

	g_arecPos[4].left = 55;
	g_arecPos[4].top = 10;
	g_arecPos[4].right = 63;
	g_arecPos[4].bottom = 18;

	/* d */
	g_arecKey[5].left = 61;
	g_arecKey[5].top = 0;
	g_arecKey[5].right = 80;
	g_arecKey[5].bottom = 40;

	g_arecPos[5].left = 64;
	g_arecPos[5].top = 30;
	g_arecPos[5].right = 75;
	g_arecPos[5].bottom = 38;

	/* d# */
	g_arecKey[6].left = 74;
	g_arecKey[6].top = 0;
	g_arecKey[6].right = 84;
	g_arecKey[6].bottom = 20;

	g_arecPos[6].left = 75;
	g_arecPos[6].top = 10;
	g_arecPos[6].right = 83;
	g_arecPos[6].bottom = 18;

	/* e */
	g_arecKey[7].left = 81;
	g_arecKey[7].top = 0;
	g_arecKey[7].right = 100;
	g_arecKey[7].bottom = 40;

	g_arecPos[7].left = 84;
	g_arecPos[7].top = 30;
	g_arecPos[7].right = 95;
	g_arecPos[7].bottom = 38;

	/* f */
	g_arecKey[8].left = 101;
	g_arecKey[8].top = 0;
	g_arecKey[8].right = 120;
	g_arecKey[8].bottom = 40;

	g_arecPos[8].left = 104;
	g_arecPos[8].top = 30;
	g_arecPos[8].right = 115;
	g_arecPos[8].bottom = 38;

	/* f# */
	g_arecKey[9].left = 114;
	g_arecKey[9].top = 0;
	g_arecKey[9].right = 124;
	g_arecKey[9].bottom = 20;

	g_arecPos[9].left = 115;
	g_arecPos[9].top = 10;
	g_arecPos[9].right = 123;
	g_arecPos[9].bottom = 18;

	/* g */
	g_arecKey[10].left = 121;
	g_arecKey[10].top = 0;
	g_arecKey[10].right = 140;
	g_arecKey[10].bottom = 40;

	g_arecPos[10].left = 124;
	g_arecPos[10].top = 30;
	g_arecPos[10].right = 135;
	g_arecPos[10].bottom = 38;

	/* g# */
	g_arecKey[11].left = 134;
	g_arecKey[11].top = 0;
	g_arecKey[11].right = 144;
	g_arecKey[11].bottom = 20;

	g_arecPos[11].left = 135;
	g_arecPos[11].top = 10;
	g_arecPos[11].right = 143;
	g_arecPos[11].bottom = 18;

	/* a */
	g_arecKey[12].left = 141;
	g_arecKey[12].top = 0;
	g_arecKey[12].right = 160;
	g_arecKey[12].bottom = 40;

	g_arecPos[12].left = 144;
	g_arecPos[12].top = 30;
	g_arecPos[12].right = 155;
	g_arecPos[12].bottom = 38;

	/* b- */
	g_arecKey[13].left = 154;
	g_arecKey[13].top = 0;
	g_arecKey[13].right = 164;
	g_arecKey[13].bottom = 20;

	g_arecPos[13].left = 155;
	g_arecPos[13].top = 10;
	g_arecPos[13].right = 163;
	g_arecPos[13].bottom = 18;

	/* b */
	g_arecKey[14].left = 161;
	g_arecKey[14].top = 0;
	g_arecKey[14].right = 180;
	g_arecKey[14].bottom = 40;

	g_arecPos[14].left = 164;
	g_arecPos[14].top = 30;
	g_arecPos[14].right = 175;
	g_arecPos[14].bottom = 38;

	/* c */
	g_arecKey[15].left = 181;
	g_arecKey[15].top = 0;
	g_arecKey[15].right = 200;
	g_arecKey[15].bottom = 40;

	g_arecPos[15].left = 184;
	g_arecPos[15].top = 30;
	g_arecPos[15].right = 195;
	g_arecPos[15].bottom = 38;

	/* c# */
	g_arecKey[16].left = 194;
	g_arecKey[16].top = 0;
	g_arecKey[16].right = 204;
	g_arecKey[16].bottom = 20;

	g_arecPos[16].left = 195;
	g_arecPos[16].top = 10;
	g_arecPos[16].right = 203;
	g_arecPos[16].bottom = 18;

	/* d */
	g_arecKey[17].left = 201;
	g_arecKey[17].top = 0;
	g_arecKey[17].right = 220;
	g_arecKey[17].bottom = 40;

	g_arecPos[17].left = 204;
	g_arecPos[17].top = 30;
	g_arecPos[17].right = 215;
	g_arecPos[17].bottom = 38;

	/* d# */
	g_arecKey[18].left = 214;
	g_arecKey[18].top = 0;
	g_arecKey[18].right = 224;
	g_arecKey[18].bottom = 20;

	g_arecPos[18].left = 215;
	g_arecPos[18].top = 10;
	g_arecPos[18].right = 223;
	g_arecPos[18].bottom = 18;

	/* e */
	g_arecKey[19].left = 221;
	g_arecKey[19].top = 0;
	g_arecKey[19].right = 240;
	g_arecKey[19].bottom = 40;

	g_arecPos[19].left = 224;
	g_arecPos[19].top = 30;
	g_arecPos[19].right = 235;
	g_arecPos[19].bottom = 38;

	g_hInstance = hInstance;

	wndclass.style         = CS_HREDRAW | CS_VREDRAW;
	wndclass.lpfnWndProc   = WndProc;
	wndclass.cbClsExtra    = 0;
	wndclass.cbWndExtra    = 0;
	wndclass.hInstance     = g_hInstance;
	wndclass.hIcon         = LoadIcon(NULL, IDI_APPLICATION);
	wndclass.hCursor       = LoadCursor(NULL, IDC_ARROW);
	wndclass.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
	wndclass.lpszMenuName  = NULL;
	wndclass.lpszClassName = "CWindow";

	RegisterClass(&wndclass);

	/* EChETCYvZ */
	AdjustWindowRect(&g_recKey, WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU, FALSE);

	/* EChE쐬 */
	g_hwMain = CreateWindow("CWindow", "3Ցty",
	          WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU,
	          CW_USEDEFAULT, CW_USEDEFAULT,
			  g_recKey.right - g_recKey.left, g_recKey.bottom - g_recKey.top, 
	          NULL, NULL, hInstance, NULL);

	/* EChE\ */
	ShowWindow(g_hwMain, iCmdShow);
	UpdateWindow(g_hwMain);

	/* C[v */
	while (1) {

		if (PeekMessage(&msg, NULL, 0, 0, PM_NOREMOVE)) {

			/* bZ[W */
			if (!GetMessage(&msg, NULL, 0, 0)) {
				break;
			}

			TranslateMessage(&msg);
			DispatchMessage(&msg);

		} else {
			midi();
		}

		Sleep(5);

	}

	SelectObject(g_hdcKey, g_hbmpOld);
	DeleteObject(g_hbmpKey);
	DeleteDC(g_hdcKey);
	DeleteObject(g_hbPos);

	midiOutReset(g_hMidi);
	midiOutClose(g_hMidi);

	return msg.wParam;

}

LRESULT CALLBACK WndProc(HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam) {	

	HDC hdc;
	PAINTSTRUCT ps;

	switch (iMsg) {

	case WM_PAINT:

		hdc=BeginPaint(hwnd,&ps);

		BitBlt(hdc, 0, 0, 320, 40, g_hdcKey, 0, 0, SRCCOPY);
		EndPaint(hwnd,&ps);

		return 0;

	case WM_DESTROY:

		PostQuitMessage(0);

		return 0;

	}

	return DefWindowProc(hwnd, iMsg, wParam, lParam);

}
